﻿//////////////////////////////////////////////////////////////////////////////
// CustomerDisconnectNotification.cs
//
// Copyright 2015 Avaya Inc. All Rights Reserved.
//
// Usage of this source is bound to the terms described in
// Licenses/License.txt
//
// Avaya - Confidential & Proprietary. Use pursuant to your signed agreement or
// Avaya Policy
//////////////////////////////////////////////////////////////////////////////

using Newtonsoft.Json;

namespace EncoderDecoder.Notifications
{
    public class CustomerDisconnectNotification : IBaseNotification
    {
        public CustomerDisconnectNotification()
        {
            this.body = new Body();
        }

        public string apiVersion { get; set; }
        public string type { get; set; }
        public Body body { get; set; }

        public class Body
        {
            public Body()
            {
                this.closedReasonCodes = new ClosedReasonCodes();
            }
            public string method { get; set; }
            public long guid { get; set; }
            public long timestamp { get; set; }
            public ClosedReasonCodes closedReasonCodes { get; set; }
        }

        /// <summary>
        /// Decodes this notifications and returns object representation.
        /// </summary>
        /// <param name="json"></param>
        /// <returns></returns>
        public IBaseNotification Decode(string json)
        {
            return JsonConvert.DeserializeObject<CustomerDisconnectNotification>(json);
        }

    }
}
