﻿//////////////////////////////////////////////////////////////////////////////
// IsTypingRequestTest.cs
//
// Copyright 2015 Avaya Inc. All Rights Reserved.
//
// Usage of this source is bound to the terms described in
// Licenses/License.txt
//
// Avaya - Confidential & Proprietary. Use pursuant to your signed agreement or
// Avaya Policy
//////////////////////////////////////////////////////////////////////////////

using EncoderDecoder;
using EncoderDecoder.Requests;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace EncoderDecoderUnitTest
{
    [TestClass]
    public class IsTypingRequestTest
    {
        [TestMethod]
        public void IsTypingRequestTest_SimpleEncode()
        {
            String jsonExpected = @"{""apiVersion"":""1.0"",""type"":""request"",""body"":{""method"":""isTyping"",""guid"":123456,""messageType"":""normal"",""isTyping"":true}}";

            IsTypingRequest temp = new IsTypingRequest();
            temp.apiVersion = IsTypingRequest.JSapiVersion.one_point_zero;

            temp.body.guid = 123456;
            temp.body.messageType = BaseRequest.JSmessageType.normal;
            temp.body.isTyping = true;

            JEncoder e = new JEncoder();
            String response = e.Encode(temp);

            Assert.AreEqual(response, jsonExpected);

        }
    }
}
